Description
===========

Manages Windows {2003,2008} Scheduled Tasks via settings stored inside chef data bags.

https://github.com/cixelsyd/cookbooks/tree/master/kronos

Kronos version >= 1.0.1 is a complete re-write for chef-client version 11!  Previously, all kronos-managed tasks were completely removed and re-created on each chef run.  Now kronos only modifies discrete tasks as appropriate.

Requirements
============

Windows, Task Scheduler version 1 or 2.

Attributes
==========

Attributes are extremely limited and mostly point at templates.  All task configuration information is located inside data bags.  See "schedule.rb" attribute file for details.

Usage
=====

Give tasks a name and place their settings into a data bag.  Then create another data bag that contains the hostnames of your nodes and attach a comma-delineated list of task names to each node.  Kronos will ensure that the tasks are appropriately scheduled on the servers.  Additionally, kronos now keeps the working directory clean of all non-active task xml files, so no zombie tasks will get rescheduled if they were previously removed from the host data bag!

Kronos for Windows 2003 is more simplistic than the 2008 version.  For Windows 2003, Kronos does not permit "non-managed" tasks, as it deletes all tasks at the beginning of each run.  On Windows 2003, if the task does not have the correct data bag entry, it will be deleted by Kronos on the subsequent run.  This was for simplicity sake.  Kronos for 2003 accepts all the main task scheduler version 1.0 settings; see "create_task.bat.erb" for the command line that is run, and the "schedule.rb" attribute file for additional information.

Kronos for Windows 2008 is slightly more advanced in that it permits "non-managed" tasks to co-exist with Kronos tasks.  All tasks that are managed by Kronos have a "kronos-" prefix; this is the primary method of distinguishing between them.  Kronos for Windows 2008 currently accepts slightly fewer schedule options than Windows 2003; at the moment they are limited to "minute", "hourly", "daily", "weekly" and "monthly".  NOTE! "Monthly" currently means something different for Task Scheduler version 1.0 and 2.0; in Task Scheduler 2.0 it means "once-a-month". The "modifier" setting for "monthly" type tasks represents the number of "the day of the month" on the calendar.  Ditto, "weekly" utilizes the "modifier" setting in a crontab-esk manner (0=Sunday, 5=Friday, etc). Other scheduling options will be added at a later date as the task.xml.erb file is expanded.  See "schedule.rb" attribute file for details.

Note that task scheduler 2.0 for Windows 2008 is significantly more complicated than version 1.0, hence the mucking about with the registry.

Kronos version >= 1.0.1 now works even better with chef-client version >= 11.6.0!  Kronos does not modify tasks unless specifically necessary, and also ensures that any tasks that had been deleted manually from machines are re-created appropriately on the subsequent chef run.  Kronos >= 1.0.1 and chef-client >= 11.6.0 are highly preferred!